/* -*- c++ -*-
 * tkresolver - Telekinesis testing software
 *
 * Copyright (C) 2004-2007 Robert Ham <rah@bash.sh>
 *
 * GPL all the way, baby :)
 *
 */

#ifndef __TK_EXP_COMBO_BOX_SPIN_H__
#define __TK_EXP_COMBO_BOX_SPIN_H__

#include <gtkmm.h>

#include "libtkcommon/tkstring.h"

namespace TkResolver {
  namespace Experimenter {

    class ComboBoxSpin : public Gtk::ComboBox
      {
      private:
	class Columns : public Gtk::TreeModel::ColumnRecord
	  {
	  public:
	    Gtk::TreeModelColumn<double> numerical_value;
	    Gtk::TreeModelColumn<Glib::ustring> description;
	    Columns() { add(numerical_value); add(description); }
	  };
	
	guint                        _digits;
	Columns                      _columns;
	Glib::RefPtr<Gtk::ListStore> _store;
	
	String get_value_description(double value);
	void combo_change_handler();
	
      protected:
	Gtk::SpinButton              _spin;
      public:
	ComboBoxSpin(double climb_rate = 0.0,
		     guint digits = 0);
	void set_adjustment(Gtk::Adjustment &adj);

	void add_value(double value, const String *description = 0);
	double get_value() const;
	void set_value(double value);
      };

  } /* namespace Experimenter */
}; /* namespace TkResolver */

#endif /* __TK_EXP_COMBO_BOX_SPIN_H__ */
