/*
 * tkresolver - Telekinesis testing software
 *
 * Copyright (C) 2004-2007 Robert Ham <rah@bash.sh>
 *
 * GPL all the way, baby :)
 *
 */

#include <boost/assign/list_of.hpp>

#include "intent_selector.h"

using namespace TkResolver;
using namespace Experimenter;



IntentSelector:: IntentSelector(Db::Database * database, unsigned trace_count)
  : _store( Gtk::ListStore::create(_columns) )
{
  set_model(_store);
  append_column("Code", _columns.code);
  append_column("Description", _columns.description);
  
  fill_list(database, trace_count);
}

void
IntentSelector:: fill_list(Db::Database * database, unsigned trace_count) {
  Db::IntentInfoList info( database->get_intent_options(trace_count) );
  std::string deflt( database->choose_intent(trace_count) );
  
  for (Db::IntentInfoList::iterator iter( info.begin() );
       iter != info.end();
       ++iter)
    {
      Gtk::ListStore::iterator row( _store->append() );
      
      std::string code(iter->first);
      std::string description(iter->second);
      row->set_value(_columns.code, Glib::ustring(code));
      row->set_value(_columns.description, Glib::ustring(description));
      
      // default
      if (code == deflt)
	get_selection()->select(row);
    }
}

/*
bool
IntentSelector:: default_row_foreach(const TreeModel::Path &path, const TreeModel::iterator &iter, const Db::Code &default)
{
  if (Db::Code(iter->get_value(_columns.code)) == default)
    {
      
    }
}

void
IntentSelector:: set_default(Db::Database * database, unsigned trace_count) {
  Db::Code default( database->choose_intent(trace_count) );
  
  Gtk::TreeModel::SlotForeachPathAndIter slot( sigc::bind<Db::Code>(sig::mem_fun(*this, &IntentSelector::default_row_foreach), default) );

}
*/

Db::Code
IntentSelector:: get_intent_code()
{
  return get_selection()->get_selected()->get_value(_columns.code);
}
