/*
 * tkresolver - Telekinesis testing software
 *
 * Copyright (C) 2004-2007 Robert Ham <rah@bash.sh>
 *
 * GPL all the way, baby :)
 *
 */

#include "libtkcommon/debug.h"
#include "libtkrandom/retriever_registry.h"
#include "randomness_source.h"

using namespace TkResolver;
using namespace Random;
using namespace Experimenter;

RandomnessSource:: RandomnessSource()
{
  StringList sources( RetrieverRegistry::get_names() );
  
  for (StringList::iterator iter = sources.begin();
       iter != sources.end();
       ++iter)
    {
      append_text(wstring_to_ustring(*iter));
    }
  
  for (StringList::iterator iter = sources.begin();
       iter != sources.end();
       ++iter)
    {
      if (RetrieverRegistry::is_true_randomness(*iter))
	{
	  set_active_text(wstring_to_ustring(*iter));
	  break;
	}
    }
  
  if (!get_active())
    {
      set_active(0);
    }
}

String
RandomnessSource:: get_randomness_source() const
{ 
  return get_active_text();
}
