/* 
 * tkresolver - Telekinesis testing software
 *
 * Copyright (C) 2007 Robert Ham <rah@bash.sh>
 *
 * GPL all the way, baby :)
 *
 */

#include "experimenter/speed.h"

using namespace TkResolver;
using namespace Experimenter;

Speed:: Speed()
  : _adjustment(0.1, 0.0, 10.0, 0.001, 0.01),
    _scroll("Scroll")
{
  set_spacing(8);
  
  pack_start(_scroll, false, true);
  _scroll.set_active();
  _scroll.signal_toggled().connect( sigc::mem_fun(*this, &Speed::scroll_toggled) );
  
  pack_start(_speed, true, true);
  _speed.set_adjustment(_adjustment);
  _speed.set_digits(4);
}

void
Speed:: scroll_toggled()
{
  bool scrolled( get_scrolled() );
  _speed.set_sensitive(scrolled);
  _signal_scroll_changed.emit(scrolled);
}

Speed::ScrollChanged *
Speed:: signal_scroll_changed()
{
  return &_signal_scroll_changed;
}

double
Speed:: get_speed() const
{
  return _speed.get_value();
}

bool
Speed::get_scrolled() const
{
  return _scroll.get_active();
}
