/* -*- c++ -*-
 * tkresolver - Telekinesis testing software
 *
 * Copyright (C) 2004-2007 Robert Ham <rah@bash.sh>
 *
 * GPL all the way, baby :)
 *
 */

#ifndef __TK_DB_UI_LOGIN_H__
#define __TK_DB_UI_LOGIN_H__

#include <gtkmm.h>
#include <gconfmm.h>

#include "libtkcommon/tkstring.h"
#include "libtkcommon/debug.h"

namespace TkResolver {
  namespace Db {
    namespace Ui {
      
      class Login : public Gtk::Dialog
	{
	private:
	  Glib::RefPtr<Gnome::Conf::Client> _conf;

	  Gtk::ComboBoxText _data_source_name;
	  Gtk::Entry        _username;
	  Gtk::Entry        _password;
	  
	  void fill_data_source_names();
	  
	public:
	  Login();
	  ~Login();
	  String get_data_source_name() const;
	  String get_username() const;
	  String get_password() const;
	};
      
    } /* namespace Ui */
  } /* namespace Db */
} /* namespace TkResolver */




#endif /* __TK_DB_UI_LOGIN_H__ */
