/*
 * tkresolver - Telekinesis testing software
 *
 * Copyright (C) 2004 Robert Ham <rah@bash.sh>
 *
 * GPL all the way, baby :)
 *
 */

#include "random_types.h"

using namespace TkResolver;
using namespace Random;

BitIStream *
Bits:: get_data () const
{
  std::basic_ostringstream<BitChar> data;

  unsigned bit_count = size();

  unsigned char_index(0);
  BitChar c(0);
  for (const_iterator iter = begin();
       iter != end();
       ++iter)
    {
      c |= *iter << (BITS_PER_CHAR - char_index);

      ++char_index;
      if (char_index == BITS_PER_CHAR)
	{
	  data << c;
	  char_index = 0;
	}
    }
  
  if (char_index != 0)
    data << c;
  
  return new BitIStream(data.str());
}

Bits::size_type
Bits:: get_data_len() const
{
  size_type bit_count( size() );
  return (bit_count / BITS_PER_CHAR) + ((bit_count % BITS_PER_CHAR > 1) ? 1 : 0);
}
